package com.ruoyi.framework.mybatis.aspectj;

import com.ruoyi.common.annotation.TenantIgnore;
import com.ruoyi.framework.mybatis.holder.TenantHolder;
import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;

/**
 * 租户拦截器
 */
@Aspect
public class TenantAspect {

    @Around("@annotation(tenantIgnore)")
    public Object around(ProceedingJoinPoint point, TenantIgnore tenantIgnore) throws Throwable {
        try {
            // 开启忽略
            TenantHolder.setIgnore(Boolean.TRUE);
            // 执行方法
            return point.proceed();
        } finally {
            // 关闭忽略
            TenantHolder.clear();
        }
    }

}
